package sax03;

import java.io.File;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class DemoSaxParsing extends DefaultHandler {

   public static void main(String[] args) throws Exception {

      System.out.printf("Run DemoSaxParsing: Read data/centralpark.osm ... \n");
      System.out.printf("============================================= ... \n");

      DefaultHandler handler = new DemoSaxParsing();

      SAXParserFactory factory = SAXParserFactory.newInstance();
      factory.setValidating(false);

      SAXParser parser = factory.newSAXParser();
      parser.parse(new File("data/centralpark.osm"), handler);

      System.out.printf("============================================= ... \n");
      System.out.printf("Finished ... \n");
   }
	
   @Override
   public void startElement(String uri, String localName, String qName, Attributes attributes) throws SAXException {
		
      // get the number of attributes in the list

      int length = attributes.getLength();

      // process each attribute

      for (int i=0; i<length; i++) {

         // get qualified (prefixed) name by index

         String name = attributes.getQName(i);

         // get attribute's value by index.

         String value = attributes.getValue(i);

         // get namespace URI by index (if parser is namespace-aware)

         String nsUri = attributes.getURI(i);

         // get local name by index

         String lName = attributes.getLocalName(i);

         System.out.printf("--- name: %s, value: %s, local name: %s ...\n", name, value, lName );
     }
  }
}
