/*
 *  =======================================================================
 *  Matrix.java: Matrix Interface file ....
 *
 *  Basic implementation of an M-by-N matrix and matrix operations
 *
 *  Written by: Mark Austin                                       July 2013
 *  =======================================================================
 */

package whistle;

import java.lang.Math;
import java.util.*;
import java.io.*;
import java.text.*;

public interface Matrix {
    public void      setName( String sName );
    public String    getName();
    public Quantity  getElement( int i, int j );
    public void      setElement( int i, int j, Quantity value );
    public int       getNoRows();
    public int       getNoColumns();
    public double    getData( int i, int j );
    public void      setData( int i, int j, double value );
    public Matrix    transpose();
    public Matrix    scale ( Quantity scaleFactor );
    public Matrix    pow ( double exponent );
    public Matrix    add( Matrix B );
    public Matrix    sub( Matrix B );
    public Matrix    mult( Matrix B );
    public Matrix    solve( Matrix rhs );
    public Matrix    copy();
    public void      print();
    public String    toString();
}
