/*
 *  =================================================================
 *  BuiltinMax.java: Specification for builtin function max (x,y)....
 *
 *  Written by: Mark Austin                                 June 2013
 *  =================================================================
 */

package whistle.builtins;

import java.lang.Math;
import whistle.*;

public class BuiltinMax implements FunctionQuantity {
   Quantity a, b, c, d;
   int noArgs = 0;
   boolean DEBUG = false;

   public BuiltinMax () {}

   public int getNoArgs() {
      return noArgs;
   }

   public void setValues ( Quantity ... numbers ) {
      noArgs = numbers.length;
      this.a = numbers[0];
      this.b = numbers[1];

      if ( DEBUG == true ) {
         System.out.println("*** In whistle/builtins/Max.setValues() ....");
         System.out.println("*** noArgs = " + noArgs );
      }
   }

   public String getName() {
      return "Max";
   }

   public Quantity compute() {
      Quantity result;
      if ( DEBUG == true ) {
         System.out.println("*** Enter whistle/builtins/Quantity.compute() ... ");
      }

      switch ( noArgs ) {
         case 2:
              result = a.max(b);
              break;
         case 3:
              result = a.max(b).max(c);
              break;
         case 4:
              result = a.max(b).max(c).max(d);
              break;
         default:
              result = new Quantity();
              break;
      }

      if ( DEBUG == true ) {
         System.out.println("*** Result = " + result.toString() );
      }

      return result;
   }

   // String representation of Max() function ...

   public String toString() {
      StringBuffer buf = new StringBuffer();
      buf.append( String.format("whistle/builtins/Max() function : noArgs = %2d\n", noArgs ) );
      return buf.toString();
   }
}

